<?php
/*
Plugin Name: Auto-Close Comments/ Trackbacks
Version:     0.3
Plugin URI:  http://codex.wordpress.org/Plugins/Auto_shutoff_comments
Description: Autoclose comments and trackbacks after 21 days.
Author:      Scott Hanson
Author URI:  http://www.papascott.de/
*/

/* Add an index on comment_status/ ping_status to wp_posts to speed this up. */
/* Little Modifikation by Frank Bueltge - http://bueltge.de */

function autoclose_comments() {
    global $wpdb, $tableposts;

    if (!isset($tableposts))
        $tableposts = $wpdb->posts;

    // Set $age to the age at which a post should become stale
    $age = '21 DAY';

    $date = $wpdb->get_var("
        SELECT DATE_ADD(DATE_SUB(CURDATE(), INTERVAL $age), INTERVAL 1 DAY)
    ");

    $wpdb->query("
        UPDATE $tableposts
        SET comment_status = 'closed'
        WHERE comment_status = 'open'
        AND post_status = 'publish'
        AND post_date < '$date'
    ");
}

function autoclose_trackback() {
    global $wpdb, $tableposts;

    if (!isset($tableposts))
        $tableposts = $wpdb->posts;

    // Set $age to the age at which a post should become stale
    $age = '21 DAY';

    $date = $wpdb->get_var("
        SELECT DATE_ADD(DATE_SUB(CURDATE(), INTERVAL $age), INTERVAL 1 DAY)
    ");

    $wpdb->query("
        UPDATE $tableposts
        SET ping_status = 'closed'
        WHERE comment_status = 'open'
        AND post_status = 'publish'
        AND post_date < '$date'
    ");
}

add_action('publish_post',   'autoclose_trackback', 7);
add_action('edit_post',      'autoclose_trackback', 7);
add_action('delete_post',    'autoclose_trackback', 7);
add_action('comment_post',   'autoclose_trackback', 7);
add_action('trackback_post', 'autoclose_trackback', 7);
add_action('pingback_post',  'autoclose_trackback', 7);
add_action('edit_comment',   'autoclose_trackback', 7);
add_action('delete_comment', 'autoclose_trackback', 7);
add_action('template_save',  'autoclose_trackback', 7);

add_action('publish_post',   'autoclose_comments', 7);
add_action('edit_post',      'autoclose_comments', 7);
add_action('delete_post',    'autoclose_comments', 7);
add_action('comment_post',   'autoclose_comments', 7);
add_action('trackback_post', 'autoclose_comments', 7);
add_action('pingback_post',  'autoclose_comments', 7);
add_action('edit_comment',   'autoclose_comments', 7);
add_action('delete_comment', 'autoclose_comments', 7);
add_action('template_save',  'autoclose_comments', 7);
?>